#ifndef HERMESFW_H
#define HERMESFW_H

#include "hermes_mem.h"

#define s_swap(a) ((((a)&0xFF)<<8) | ((a)>>8))
#define l_swap(a) ((((a)&0xFF)<<24) | (((a)&0xFF00)<<8) | (((a)&0xFF0000)>>8) | ((a)>>24))

#if __BYTE_ORDER == __BIG_ENDIAN
#define le16_to_host(a) s_swap(a)
#define host_to_le16(a) s_swap(a)
#define le32_to_host(a) l_swap(a)
#define be16_to_host(a) (a)
#define be32_to_host(a) (a)
#elif __BYTE_ORDER == __LITTLE_ENDIAN
#define le16_to_host(a) (a)
#define host_to_le16(a) (a)
#define le32_to_host(a) (a)
#define be16_to_host(a) s_swap(a)
#define be32_to_host(a) l_swap(a)
#else
#error "Leave your PDP alone"
#endif

#define u32 unsigned long
#define u16 unsigned short
#define u8 unsigned char

#define PAGE_POF_TO_OFFSET(a,b) (((a)*pagesize)+b)
#define PAGE_TO_OFFSET(a) PAGE_POF_TO_OFFSET((a),0)
#define OFFSET_TO_PAGE(a) ((a)/pagesize)
#define OFFSET_TO_POF(a) ((a)%pagesize)

#endif /* HERMESFW_H */
