#ifndef HFW_H
#define HFW_H

#include <stdio.h>
#include "hermesfw.h"

#define SKIP_SPACES(a) while(((a)[0]==0x20) || ((a)[0]==0x09)) (a)++;

struct plugrecord {
	unsigned long code; /* FF00 XXXX: PDR, FF10 XXXX: CRC16, FF20 XXXX: FW Info */
	unsigned long offset;
	unsigned long length; /* if 1 and code&0xFF10FFFF -> write CRC to card */
};

struct segment {
	unsigned long offset;
	unsigned long length;
	unsigned long unknown;
	
	unsigned short data_len;
	unsigned char *data;
};

struct hfw {
	unsigned long entry;
	struct plugrecord *plugs;
	struct segment *segms;
};

int hex2bin(char *in, unsigned char *out, int max);
void free_hfw(struct hfw *hfw);
struct hfw *read_hfw(unsigned char *file);
int write_hfw_plugs(FILE *fl, struct plugrecord *recs);
int hfw_plug_records(struct hfw *hfw, unsigned char *opda, unsigned char *pda, int verbose);
int hfw_upload(struct hfw *hfw, int fd);
void dump_segments(struct segment *sr);
#endif
